'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var HeadWrapper = function () {
  function HeadWrapper(headContractAddress, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, HeadWrapper);

    if (headContractAddress === undefined) {
      throw new Error('Head contract address is not configured');
    }

    this.web3 = web3;
    this.defaultAddress = defaultAddress;
    this.head = (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default.head.abi, headContractAddress);
  }

  (0, _createClass3.default)(HeadWrapper, [{
    key: 'setDefaultAddress',
    value: function setDefaultAddress(defaultAddress) {
      this.defaultAddress = defaultAddress;
    }
  }, {
    key: 'contractAddressByName',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(contractName) {
        var availableContracts, catalogue;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                availableContracts = ['kycWhitelist', 'roles', 'fees', 'challenges', 'payouts', 'shelteringTransfers', 'sheltering', 'uploads', 'config'];

                if (availableContracts.includes(contractName)) {
                  _context.next = 3;
                  break;
                }

                throw new Error('Requested contract does not exist');

              case 3:
                _context.next = 5;
                return this.catalogue();

              case 5:
                catalogue = _context.sent;
                return _context.abrupt('return', catalogue.methods[contractName + '()']().call());

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function contractAddressByName(_x) {
        return _ref.apply(this, arguments);
      }

      return contractAddressByName;
    }()
  }, {
    key: 'setContext',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(address) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.head.methods.setContext(address).send({
                  from: this.defaultAddress
                });

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function setContext(_x2) {
        return _ref2.apply(this, arguments);
      }

      return setContext;
    }()
  }, {
    key: 'context',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var contextAddress;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.head.methods.context().call();

              case 2:
                contextAddress = _context3.sent;
                return _context3.abrupt('return', (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default.context.abi, contextAddress));

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function context() {
        return _ref3.apply(this, arguments);
      }

      return context;
    }()
  }, {
    key: 'catalogue',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var context, catalogueAddress;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.context();

              case 2:
                context = _context4.sent;
                _context4.next = 5;
                return context.methods.catalogue().call();

              case 5:
                catalogueAddress = _context4.sent;
                return _context4.abrupt('return', (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default.catalogue.abi, catalogueAddress));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function catalogue() {
        return _ref4.apply(this, arguments);
      }

      return catalogue;
    }()
  }, {
    key: 'getOwner',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', this.head.methods.owner().call());

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getOwner() {
        return _ref5.apply(this, arguments);
      }

      return getOwner;
    }()
  }]);
  return HeadWrapper;
}();

exports.default = HeadWrapper;